# Jasper Veerman adapted this script from the color_h script from source below. 
# -------
 
# PyMOL command to color protein molecules according to their charge. 
# Positive charge: 	value +1 (blue): Lys, Arg, His
# Negative charge: 	value -1 (red): Asp, Glu
# Zero charge: 		value 0 (white): else

# Charge information from: http://www.imgt.org/IMGTeducation/Aide-memoire/_UK/aminoacids/charge/
 
# Inspiration from original script: 
# Swiss Institute of Bioinformatics - ProtScale Tool: Amino acid scale: Normalized consensus hydrophobicity scale.
#
# Amino acid scale values:
#
# Ala:  0.000
# Arg: 	1.000
# Asn: 	0.000
# Asp: -1.000
# Cys: 	0.000
# Gln: 	0.000
# Glu: -1.000
# Gly: 	0.000
# His: 	1.000
# Ile: 	0.000
# Leu: 	0.000
# Lys: 	1.000
# Met: 	0.000
# Phe:  0.000
# Pro:  0.000
# Ser: 	0.000
# Thr: 	0.000
# Trp:  0.000
# Tyr:  0.000
# Val:  0.000
#
# Usage:
# color_charge (selection)
#
from pymol import cmd

def color_charge(selection='all'):
        s = str(selection)
	print s
        cmd.set_color('color_ile',[1.000,1.000,1.000])
        cmd.set_color('color_phe',[1.000,1.000,1.000])
        cmd.set_color('color_val',[1.000,1.000,1.000])
        cmd.set_color('color_leu',[1.000,1.000,1.000])
        cmd.set_color('color_trp',[1.000,1.000,1.000])
        cmd.set_color('color_met',[1.000,1.000,1.000])
        cmd.set_color('color_ala',[1.000,1.000,1.000])
        cmd.set_color('color_gly',[1.000,1.000,1.000])
        cmd.set_color('color_cys',[1.000,1.000,1.000])
        cmd.set_color('color_tyr',[1.000,1.000,1.000])
        cmd.set_color('color_pro',[1.000,1.000,1.000])
        cmd.set_color('color_thr',[1.000,1.000,1.000])
        cmd.set_color('color_ser',[1.000,1.000,1.000])
        cmd.set_color('color_his',[0.000,0.000,1.000])
        cmd.set_color('color_glu',[1.000,0.000,0.000])
        cmd.set_color('color_asn',[1.000,1.000,1.000])
        cmd.set_color('color_gln',[1.000,1.000,1.000])
        cmd.set_color('color_asp',[1.000,0.000,0.000])
        cmd.set_color('color_lys',[0.000,0.000,1.000])
        cmd.set_color('color_arg',[0.000,0.000,1.000])
        cmd.color("color_ile","("+s+" and resn ile)")
        cmd.color("color_phe","("+s+" and resn phe)")
        cmd.color("color_val","("+s+" and resn val)")
        cmd.color("color_leu","("+s+" and resn leu)")
        cmd.color("color_trp","("+s+" and resn trp)")
        cmd.color("color_met","("+s+" and resn met)")
        cmd.color("color_ala","("+s+" and resn ala)")
        cmd.color("color_gly","("+s+" and resn gly)")
        cmd.color("color_cys","("+s+" and resn cys)")
        cmd.color("color_tyr","("+s+" and resn tyr)")
        cmd.color("color_pro","("+s+" and resn pro)")
        cmd.color("color_thr","("+s+" and resn thr)")
        cmd.color("color_ser","("+s+" and resn ser)")
        cmd.color("color_his","("+s+" and resn his)")
        cmd.color("color_glu","("+s+" and resn glu)")
        cmd.color("color_asn","("+s+" and resn asn)")
        cmd.color("color_gln","("+s+" and resn gln)")
        cmd.color("color_asp","("+s+" and resn asp)")
        cmd.color("color_lys","("+s+" and resn lys)")
        cmd.color("color_arg","("+s+" and resn arg)")
cmd.extend('color_charge',color_charge)
